#!/usr/bin/perl

require "netsaint-lib.pl";

%required = (
"password_old","Old Password",
"password_new","New Password",
"password_new2","New Password Again",
);

@FIELDS = ("password_old","password_new", "password_new2");

print <<EOF;

<html>

<head>
<title>Netsaint config</title>
</head>

<body>
EOF

if (length($in{'MODE'}) <= 0) { $in{'MODE'} = "EDIT"; }

if ($in{'MODE'} eq "EDIT")
{
	&add_edit_form;
}
elsif ($in{'MODE'} eq "SAVE")
{
	if (&verify_form ||
	    ($in{'password_old'} ne $in{'PASSWORD'}) ||
	    ($in{'password_new'} ne $in{'password_new2'}) ||
	    (length($in{'password_new'}) <= 0)
           )
	{
		
		if ($in{'password_old'} ne $in{'PASSWORD'})
		{
			print "Please enter your old password.<p>";
		}
		elsif ($in{'password_new'} ne $in{'password_new2'})
		{
			print "New password does not match.<p>";
		} 
		elsif (length($in{'password_new'}) <= 0)
		{
			print "Please enter a new password.<p>";
		}
		
		&add_edit_form;
	}
	else
	{
		&save_password;
		print <<EOF;
<p>Password <font color=red>Updated</font>.<p>
EOF
	}
}
else
{
	print <<EOF;
Invalid Mode.
EOF
}

print <<EOF;
</body>
</html>

EOF

exit(1);

sub save_password
{
	$in{'password'} =~ s/\\/\\\\/g;
	$in{'password'} =~ s/'/\\'/g;
	$in{'password'} =~ s/"/\\"/g;
	&update_password;
}

sub update_password
{
	local($csr);
	local($sql);

	$sql = "
		update users set
		password = password('$in{'password_new'}')
		where
			name = '$in{'NAME'}'
		";
	
	$csr = &my_do($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
}


sub add_edit_form
{
	print <<EOF;
<form action="change_password.cgi" method=post>
$old
<table cellpadding=0 cellspacing=0 border=0>
  <tr>
    <td bgcolor=7172a2 align=right><font color="#DCE5C1"><b>Old Password:</b></font></td>
    <td bgcolor="#E1E2ED"><input type=password name=password_old value="" size=10 maxlength=10></td>
  </tr>
  <tr>
    <td bgcolor=7172a2 align=right><font color="#DCE5C1"><b>New Password:</b></font></td>
    <td bgcolor="#E1E2ED"><input type=password name=password_new value="" size=10 maxlength=10></td>
  </tr>
  <tr>
    <td bgcolor=7172a2 align=right><font color="#DCE5C1"><b>New Password:</b></font></td>
    <td bgcolor="#E1E2ED"><input type=password name=password_new2 value="" size=10 maxlength=10></td>
  </tr>
</table>
<input type=hidden name=MODE value=SAVE>
<input type=submit value=Save name=Save>
</form>

EOF

}


