
#############################################################################
# Configuration options
#############################################################################
$dbuser    = "brazil";                       # User to log into database as
$dbname    = "netsaint";                     # Name of database
$dbpass    = "";                             # Name of database
$cgibin    = "/~brazil/nsa";                 # URL location of cgi scripts
$cgi_loc   = "/home/brazil/public_html/nsa"; # Physical location of files
$netsaint  = "/home/brazil/bin/netsaint";    # location of netsaint binary
$hosts_loc = "/home/brazil/bin";             # location of hosts.cfg file
#############################################################################
# End Configuration options
#############################################################################


$VAR{'fsize'} = "-1";
$VAR{'esize'} = "-2";
$VAR{'dsize'} = "-2";

use Myperl;
use CGI qw/:standard/;
use CGI::Cookie;
CGI::ReadParse(*in);
&load_cookie;

$dbh = "";
&MysqlLogin;


# If you require this file, then you need to login to mysql, so
# We just do it automatically

sub MysqlLogin
{
	$dbh = &my_login("$dbname", "$dbuser", "$dbpass");
	&VerifyUsername if ($no_cookie_check != 1);
}

sub list_hosts
{
	my $csr;
	my $sql;
	local( $ret);
	local( %data);
	my $odd = 1;
	my $color="";

	$sql = "select
			*
		from
			host
		order by
			host_name
		";
	print <<EOF;
<p><a href="edit_host.cgi?MODE=ADD">Add Host</a></p>
EOF

	print <<EOF;
<table align=center cellpadding=1 cellspacing=1 border=0>
  <tr bgcolor=7172a2 align=center>
    <td colspan=7>&#160;</td>
    <td colspan=5><font color="#DCE5C1" size=$VAR{'fsize'}><b>Notification</b></font></td>
    <td colspan=2>&#160;</td>
  </tr>
  <tr bgcolor=7172a2 align=center>
    <td>&#160;</td>
    <td><font color="#DCE5C1" size=$VAR{'fsize'}><b>Host Name</b></font></td>
    <td><font color="#DCE5C1" size=$VAR{'fsize'}><b>Host Alias</b></font></td>
    <td><font color="#DCE5C1" size=$VAR{'fsize'}><b>Address</b></font></td>
    <td><font color="#DCE5C1" size=$VAR{'fsize'}><b>Parent Host</b></font></td>
    <td><font color="#DCE5C1" size=$VAR{'fsize'}><b>Host Check Command</b></font></td>
    <td><font color="#DCE5C1" size=$VAR{'fsize'}><b>Max Attempts</b></font></td>
    <td><font color="#DCE5C1" size=$VAR{'fsize'}><b>Interval</b></font></td>
    <td><font color="#DCE5C1" size=$VAR{'fsize'}><b>Period</b></font></td>
    <td><font color="#DCE5C1" size=$VAR{'fsize'}><b>Recovery</b></font></td>
    <td><font color="#DCE5C1" size=$VAR{'fsize'}><b>Down</b></font></td>
    <td><font color="#DCE5C1" size=$VAR{'fsize'}><b>Unreachable</b></font></td>
    <td><font color="#DCE5C1" size=$VAR{'fsize'}><b>Event Handler</b></font></td>
    <td>&#160;</td>
  </tr>
EOF
	$csr = &my_open($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
	while ($ret = $csr->fetchrow_hashref)
	{
		if ($odd) { $odd=0; $color="E1E2ED";} else { $odd=1; $color="EEEEF4";}
		*data = $ret;
		if (length($data{'parent_host'}) <= 0) { $data{'parent_host'} = "&#160;"; }
		if (length($data{'event_handler'}) <= 0) { $data{'event_handler'} = "&#160;"; }
		print <<EOF;
  <tr bgcolor=$color>
    <td><font size=$VAR{'esize'}><a href="edit_host.cgi?MODE=EDIT&old_host_name=$data{'host_name'}">Edit</a></font></td>
    <td nowrap><font size=$VAR{'fsize'}>$data{'host_name'}</font></td>
    <td nowrap><font size=$VAR{'fsize'}>$data{'host_alias'}</font></td>
    <td nowrap><font size=$VAR{'fsize'}>$data{'address'}</font></td>
    <td nowrap><font size=$VAR{'fsize'}>$data{'parent_host'}</font></td>
    <td nowrap><font size=$VAR{'fsize'}>$data{'host_check_command'}</font></td>
    <td nowrap><font size=$VAR{'fsize'}>$data{'max_attempts'}</font></td>
    <td nowrap><font size=$VAR{'fsize'}>$data{'notification_interval'}</font></td>
    <td nowrap><font size=$VAR{'fsize'}>$data{'notification_period'}</font></td>
    <td nowrap><font size=$VAR{'fsize'}>$data{'notify_recovery'}</font></td>
    <td nowrap><font size=$VAR{'fsize'}>$data{'notify_down'}</font></td>
    <td nowrap><font size=$VAR{'fsize'}>$data{'notify_unreachable'}</font></td>
    <td nowrap><font size=$VAR{'fsize'}>$data{'event_handler'}</font></td>
    <td nowrap><font size=$VAR{'dsize'}><a href="edit_host.cgi?MODE=DELETE&host_name=$data{'host_name'}">Delete</a></font></td>
  </tr>
EOF

	}

	print "</table>\n";

	print <<EOF;
<p><a href="edit_host.cgi?MODE=ADD">Add Host</a></p>
EOF

	#&my_close($csr);
	
}

sub build_host_select
{
	local($name) = shift(@_);
	local($value) = shift(@_);
	local($size) = shift(@_);
	local($retval) = "";
	local($csr);
	local($sql);
	local(@ret);
	local($selected) = "";
	local($multiple) = "";

	if ($size > 0)
	{
		$multiple = "size=$size multiple";
	}

	$retval = "<select name=$name $multiple>\n<option value=\"\"></option>\n";

	$sql = "select host_name from host order by host_name";

	$csr = &my_open($dbh, $sql) || print "<P>$my_errstr<p>$sql<p>";
	while (@ret = &my_fetch($csr))
	{
		if ($ret[0] eq $value)
		{
			$selected = "selected";
		}
		else
		{
			$selected = "";
		}
		$retval .= "<option value=$ret[0] $selected >$ret[0]</option>\n";
	}
	$retval .= "</select>\n";
}

sub List_Contacts_Comma
{
	local($group_name) = shift(@_);
	local(@ret);
	local($sql);
	local($csr);
	local($retval)= "";
	
	$sql = "select contact_name from contactgroup_entry where group_name = '$group_name'";
	$csr = &my_open($dbh, $sql) || print "<p>$my_errstr<p>$sql</p>";
	while (@ret = &my_fetch($csr))
	{
		$retval .= "$ret[0], ";
	}
	chop($retval);
	chop($retval);
	return $retval;
}

sub List_Contactgroups_Comma
{
	local($group_name) = shift(@_);
	local(@ret);
	local($sql);
	local($csr);
	local($retval)= "";
	
	$sql = "select contact_group from hostgroup_contact where group_name = '$group_name'";
	$csr = &my_open($dbh, $sql) || print "<p>$my_errstr<p>$sql</p>";
	while (@ret = &my_fetch($csr))
	{
		$retval .= "$ret[0], ";
	}
	chop($retval);
	chop($retval);
	return $retval;
}

sub List_Hosts_Comma
{
	local($group_name) = shift(@_);
	local(@ret);
	local($sql);
	local($csr);
	local($retval)= "";
	
	$sql = "select host_name from hostgroup_entry where group_name = '$group_name'";
	$csr = &my_open($dbh, $sql) || print "<p>$my_errstr<p>$sql</p>";
	while (@ret = &my_fetch($csr))
	{
		$retval .= "$ret[0], ";
	}
	chop($retval);
	chop($retval);
	return $retval;
}

sub list_hostgroups
{
	my $csr;
	my $sql;
	local( $ret);
	local( %data);
	my $odd = 1;
	my $color="";
	local($hosts) = "&#160;";
	local($contact_groups) = "&#160;";

	$sql = "select
			*
		from
			hostgroup
		order by
			group_name
		";
	
	print <<EOF;
<p><a href="edit_hostgroup.cgi?MODE=ADD">Add Hostgroup</a></p>
EOF

	print <<EOF;
<table align=center cellpadding=1 cellspacing=1 border=0>
  <tr bgcolor=7172a2 align=center>
    <td nowrap>&#160;</td>
    <td nowrap><font color="#DCE5C1" size=$VAR{'fsize'}><b>Host Group Name</b></font></td>
    <td nowrap><font color="#DCE5C1" size=$VAR{'fsize'}><b>Group Alias</b></font></td>
    <td nowrap><font color="#DCE5C1" size=$VAR{'fsize'}><b>Contact Groups</b></font></td>
    <td nowrap><font color="#DCE5C1" size=$VAR{'fsize'}><b>Hosts</b></font></td>
    <td nowrap>&#160;</td>
  </tr>
EOF
	$csr = &my_open($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
	while ($ret = $csr->fetchrow_hashref)
	{
		if ($odd) { $odd=0; $color="E1E2ED";} else { $odd=1; $color="EEEEF4";}
		*data = $ret;

		$hosts = &List_Hosts_Comma($data{'group_name'});
		$contact_groups = &List_Contactgroups_Comma($data{'group_name'});
	
		print <<EOF;
  <tr bgcolor=$color>
    <td><font size=$VAR{'esize'}><a href="edit_hostgroup.cgi?MODE=EDIT&old_group_name=$data{'group_name'}">Edit</a></font></td>
    <td><font size=$VAR{'fsize'}>$data{'group_name'}</font></td>
    <td><font size=$VAR{'fsize'}>$data{'group_alias'}</font></td>
    <td><font size=$VAR{'fsize'}>$contact_groups (<a href="edit_hostgroup.cgi?MODE=EDIT_CONTACT&group_name=$data{'group_name'}"><font size=$VAR{'esize'}>Edit</font></a><font size=$VAR{'fsize'}>)</font></td>
    <td><font size=$VAR{'fsize'}>$hosts (<a href="edit_hostgroup.cgi?MODE=EDIT_HOST&group_name=$data{'group_name'}"><font size=$VAR{'esize'}>Edit</font></a><font size=$VAR{'fsize'}>)</font></td>
    <td><font size=$VAR{'fsize'}><a href="edit_hostgroup.cgi?MODE=DELETE&group_name=$data{'group_name'}"><font size=$VAR{'dsize'}>Delete</a></font></td>
  </tr>
EOF

	}

	print "</table>\n";

	print <<EOF;
<p><a href="edit_hostgroup.cgi?MODE=ADD">Add Hostgroup</a></p>
EOF

	#&my_close($csr);
	
}

sub List_Host_Notify_Command_Comma
{
	local($contact_name) = shift(@_);
	local(@ret);
	local($sql);
	local($csr);
	local($retval)= "";
	
	$sql = "select host_notify_command from contact_host_notify where contact_name = '$contact_name'";
	$csr = &my_open($dbh, $sql) || print "<p>$my_errstr<p>$sql</p>";
	while (@ret = &my_fetch($csr))
	{
		$retval .= "$ret[0], ";
	}
	chop($retval);
	chop($retval);
	return $retval;
}

sub List_Notify_Command_Comma
{
	local($contact_name) = shift(@_);
	local(@ret);
	local($sql);
	local($csr);
	local($retval)= "";
	
	$sql = "select 
			service_notify_command 
		from 
			contact_service_notify 
		where 
			contact_name = '$contact_name'";
	$csr = &my_open($dbh, $sql) || print "<p>$my_errstr<p>$sql</p>";
	while (@ret = &my_fetch($csr))
	{
		$retval .= "$ret[0], ";
	}
	chop($retval);
	chop($retval);
	return $retval;
}


sub list_contacts
{
	my $csr;
	my $sql;
	local($ret);
	local(%data);
	my $odd = 1;
	my $color="";

	$sql = "select
			*
		from
			contact
		order by
			contact_name
		";
	print <<EOF;
<p><a href="edit_contact.cgi?MODE=ADD">Add Contact</a></p>
EOF

	print <<EOF;
<table align=center cellpadding=1 cellspacing=1 border=0>
  <tr bgcolor=7172a2 align=center>
    <td colspan=3>&#160;</td>
    <td colspan=10 align=center><font color="#DCE5C1"><b>Notify</b></font></td>
    <td colspan=3>&#160;</td>
  </tr>
  <tr bgcolor=7172a2 align=center>
    <td colspan=3>&#160;</td>
    <td colspan=5 align=center><font color="#DCE5C1"><b>Service</b></font></td>
    <td colspan=5 align=center><font color="#DCE5C1"><b>Host</b></font></td>
    <td colspan=3>&#160;</td>
  </tr>
  <tr bgcolor=7172a2 align=center>
    <td>&#160;</td>
    <td><font color="#DCE5C1" size=$VAR{'fsize'}><b>Contact Name</b></font></td>
    <td><font color="#DCE5C1" size=$VAR{'fsize'}><b>Contact Alias</b></font></td>
    <td><font color="#DCE5C1" size=$VAR{'fsize'}><b>Period</b></font></td>
    <td><font color="#DCE5C1" size=$VAR{'fsize'}><b>Recovery</b></font></td>
    <td><font color="#DCE5C1" size=$VAR{'fsize'}><b>Critical</b></font></td>
    <td><font color="#DCE5C1" size=$VAR{'fsize'}><b>Warning</b></font></td>
    <td><font color="#DCE5C1" size=$VAR{'fsize'}><b>Notify Command</b></font></td>
    <td><font color="#DCE5C1" size=$VAR{'fsize'}><b>Period</b></font></td>
    <td><font color="#DCE5C1" size=$VAR{'fsize'}><b>Recovery</b></font></td>
    <td><font color="#DCE5C1" size=$VAR{'fsize'}><b>Down</b></font></td>
    <td><font color="#DCE5C1" size=$VAR{'fsize'}><b>Unreachable</b></font></td>
    <td><font color="#DCE5C1" size=$VAR{'fsize'}><b>Notify Command</b></font></td>
    <td><font color="#DCE5C1" size=$VAR{'fsize'}><b>Email Address</b></font></td>
    <td><font color="#DCE5C1" size=$VAR{'fsize'}><b>E-Pager</b></font></td>
    <td>&#160;</td>
  </tr>
EOF
	$csr = &my_open($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
	while ($ret = $csr->fetchrow_hashref)
	{
		if ($odd) { $odd=0; $color="E1E2ED";} else { $odd=1; $color="EEEEF4";}
		*data = $ret;
		local($notify) = &List_Notify_Command_Comma($data{'contact_name'});
		local($host_notify) = &List_Host_Notify_Command_Comma($data{'contact_name'});

		$data{'notify_service_recovery'} = &YesNo($data{'notify_service_recovery'});
		$data{'notify_service_critical'} = &YesNo($data{'notify_service_critical'});
		$data{'notify_service_warning'} = &YesNo($data{'notify_service_warning'});
		$data{'notify_host_recovery'} = &YesNo($data{'notify_host_recovery'});
		$data{'notify_host_down'} = &YesNo($data{'notify_host_down'});
		$data{'notify_host_unreachable'} = &YesNo($data{'notify_host_unreachable'});

		print <<EOF;
  <tr bgcolor=$color align=center>
    <td><font size=$VAR{'esize'}><a href="edit_contact.cgi?MODE=EDIT&old_contact_name=$data{'contact_name'}">Edit</a></font></td>
    <td><font size=$VAR{'fsize'}>$data{'contact_name'}</font></td>
    <td><font size=$VAR{'fsize'}>$data{'contact_alias'}</font></td>
    <td><font size=$VAR{'fsize'}>$data{'svc_notification_period'}</font></td>
    <td><font size=$VAR{'fsize'}>$data{'notify_service_recovery'}</font></td>
    <td><font size=$VAR{'fsize'}>$data{'notify_service_critical'}</font></td>
    <td><font size=$VAR{'fsize'}>$data{'notify_service_warning'}</font></td>
    <td><font size=$VAR{'fsize'}>$notify (<a href="edit_contact.cgi?MODE=EDIT_NOTIFY&contact_name=$data{'contact_name'}"><font size=$VAR{'esize'}>Edit</a><font size=$VAR{'fsize'}>)</font></td>
    <td><font size=$VAR{'fsize'}>$data{'host_notification_period'}</font></td>
    <td><font size=$VAR{'fsize'}>$data{'notify_host_recovery'}</font></td>
    <td><font size=$VAR{'fsize'}>$data{'notify_host_down'}</font></td>
    <td><font size=$VAR{'fsize'}>$data{'notify_host_unreachable'}</font></td>
    <td><font size=$VAR{'fsize'}>$host_notify (<a href="edit_contact.cgi?MODE=EDIT_HOST_NOTIFY&contact_name=$data{'contact_name'}"><font size=$VAR{'esize'}>Edit</a><font size=$VAR{'fsize'}>)</font></td>
    <td><font size=$VAR{'fsize'}>$data{'email_address'}</font></td>
    <td><font size=$VAR{'fsize'}>$data{'pager'}</font></td>
    <td><font size=$VAR{'dsize'}><a href="edit_contact.cgi?MODE=DELETE&contact_name=$data{'contact_name'}">Delete</a></font></td>
  </tr>
EOF

	}

	print "</table>\n";

	print <<EOF;
<p><a href="edit_contact.cgi?MODE=ADD">Add Contact</a></p>
EOF

	#&my_close($csr);
	
}


sub verify_form
{
	local($key);
	local($found) = 0;

	#foreach $key (@FIELDS)
	#{
	#	$in{$key} =~ s/'//g;
	#}
	
	#foreach $key (@NUMERIC)
	#{
	#	print "$key<br>";
	#	print "$in{$key}<br>";
	#	$in{$key} =~ s/a-zA-Z//g;
	#	print "$in{$key}<br>";
	#}

	foreach $key (keys %required)
	{
		if (length($in{$key}) <= 0)
		{
			$found++;
			print "$required{$key} is a <font color=red>REQUIRED</font> field.<br>";
		}
	}
	return $found;
}

sub list_contactgroups
{
	my $csr;
	my $sql;
	local($ret);
	local(%data);
	my $odd = 1;
	my $color="";
	my $contacts;

	$sql = "select
			*
		from
			contactgroup
		order by
			group_name
		";
	print <<EOF;
<p><a href="edit_contactgroup.cgi?MODE=ADD">Add Contactgroup</a></p>
EOF

	print <<EOF;
<table align=center cellpadding=1 cellspacing=1 border=0>
  <tr bgcolor=7172a2 align=center>
    <td colspan=1>&#160;</td>
    <td colspan=3 align=center><font color="#DCE5C1"><b>Contact Groups</b></font></td>
    <td colspan=1>&#160;</td>
  </tr>
  <tr bgcolor=7172a2 align=center>
    <td>&#160;</td>
    <td><font color="#DCE5C1" size=$VAR{'fsize'}><b>Name</b></font></td>
    <td><font color="#DCE5C1" size=$VAR{'fsize'}><b>Alias</b></font></td>
    <td><font color="#DCE5C1" size=$VAR{'fsize'}><b>Members</b></font></td>
    <td>&#160;</td>
  </tr>
EOF
	$csr = &my_open($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
	while ($ret = $csr->fetchrow_hashref)
	{
		if ($odd) { $odd=0; $color="E1E2ED";} else { $odd=1; $color="EEEEF4";}
		
		*data = $ret;
		$contacts = &List_Contacts_Comma($data{'group_name'});
		print <<EOF;
  <tr bgcolor=$color>
    <td><font size=$VAR{'esize'}><a href="edit_contactgroup.cgi?MODE=EDIT&old_group_name=$data{'group_name'}">Edit</a></font></td>
    <td><font size=$VAR{'fsize'}>$data{'group_name'}</font></td>
    <td><font size=$VAR{'fsize'}>$data{'group_alias'}</font></td>
    <td><font size=$VAR{'fsize'}>$contacts (<a href="edit_contactgroup.cgi?MODE=EDIT_CONTACT&group_name=$data{'group_name'}">Edit</a>)</font></td>
    <td><font size=$VAR{'dsize'}><a href="edit_contactgroup.cgi?MODE=DELETE&group_name=$data{'group_name'}">Delete</a></font></td>
  </tr>
EOF

	}

	print "</table>\n";

	print <<EOF;
<p><a href="edit_contactgroup.cgi?MODE=ADD">Add Contactgroup</a></p>
EOF

	#&my_close($csr);
}

sub list_commands
{
	my $csr;
	my $sql;
	local($ret);
	local(%data);
	my $odd = 1;
	my $color="";

	$sql = "select
			*
		from
			command
		order by
			command_name
		";
	print <<EOF;
<p><a href="edit_command.cgi?MODE=ADD">Add Command</a></p>
EOF

	print <<EOF;
<table align=center cellpadding=1 cellspacing=1 border=0>
  <tr bgcolor=7172a2 align=center>
    <td colspan=1>&#160;</td>
    <td colspan=2 align=center><font color="#DCE5C1" size=$VAR{'fsize'}><b>Commands</b></font></td>
    <td colspan=1>&#160;</td>
  </tr>
  <tr bgcolor=7172a2 align=center>
    <td>&#160;</td>
    <td><font color="#DCE5C1" size=$VAR{'fsize'}><b>Name</b></font></td>
    <td><font color="#DCE5C1" size=$VAR{'fsize'}><b>Line</b></font></td>
    <td>&#160;</td>
  </tr>
EOF
	$csr = &my_open($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
	while ($ret = $csr->fetchrow_hashref)
	{
		if ($odd) { $odd=0; $color="E1E2ED";} else { $odd=1; $color="EEEEF4";}
		
		*data = $ret;
		print <<EOF;
  <tr bgcolor=$color>
    <td><font size=$VAR{'esize'}><a href="edit_command.cgi?MODE=EDIT&old_command_name=$data{'command_name'}">Edit</a></font></td>
    <td><font size=$VAR{'fsize'}>$data{'command_name'}</font></td>
    <td><font size=$VAR{'fsize'}>$data{'command_line'}</font></td>
    <td><font size=$VAR{'dsize'}><a href="edit_command.cgi?MODE=DELETE&command_name=$data{'command_name'}">Delete</a></font></td>
  </tr>
EOF

	}

	print "</table>\n";

	print <<EOF;
<p><a href="edit_command.cgi?MODE=ADD">Add Command</a></p>
EOF

	#&my_close($csr);
}

sub build_command_select
{
	local($name) = shift(@_);
	local($value) = shift(@_);
	local($size) = shift(@_);
	local($retval) = "";
	local($csr);
	local($sql);
	local(@ret);
	local($selected) = "";
	local($multiple) = "";

	if ($size > 0)
	{
		$multiple = "size=$size multiple";
	}

	$retval = "<select name=$name $multiple>\n<option value=\"\"></option>\n";

	$sql = "select command_name  from command order by command_name";

	$csr = &my_open($dbh, $sql) || print "<P>$my_errstr<p>$sql<p>";
	while (@ret = &my_fetch($csr))
	{
		if ($ret[0] eq $value)
		{
			$selected = "selected";
		}
		else
		{
			$selected = "";
		}
		$retval .= "<option value=$ret[0] $selected >$ret[0]</option>\n";
	}
	$retval .= "</select>\n";
}

sub list_services
{
	my $csr;
	my $sql;
	my $ret;
	my %data;
	my $odd = 1;
	my $color="";
	my $where = "";

	if (length($in{'WHERE'}) > 0) { $where = " where $in{'WHERE'} "; }

	$sql = "select
			*
		from
			service
		$where
		order by
			host,description
		";
	print <<EOF;
<p><a href="edit_service.cgi?MODE=ADD">Add Service</a></p>
EOF

	print <<EOF;
<table align=center cellpadding=1 cellspacing=1 border=0>
  <tr bgcolor=7172a2 align=center>
    <td colspan=1>&#160;</td>
    <td colspan=2>&#160;</td>
    <td colspan=1><font color="#DCE5C1" size=$VAR{'fsize'}><b>Check</font></td>
    <td colspan=1><font color="#DCE5C1" size=$VAR{'fsize'}><b>Max</font></td>
    <td colspan=3 align=center><font color="#DCE5C1" size=$VAR{'fsize'}><b>Intervals</b></font></td>
    <td colspan=5 align=center><font color="#DCE5C1" size=$VAR{'fsize'}><b>Notify</b></font></td>
    <td colspan=1><font color="#DCE5C1" size=$VAR{'fsize'}><b>Event</font></td>
    <td colspan=2 align=center><font color="#DCE5C1" size=$VAR{'fsize'}><b>Check</b></font></td>
    <td>&#160;</td>
  </tr>
  <tr bgcolor=7172a2 align=center>
    <td>&#160;</td>
    <td><font color="#DCE5C1" size=$VAR{'fsize'}><b>Host</b></font></td>
    <td><font color="#DCE5C1" size=$VAR{'fsize'}><b>Desc.</b></font></td>
    <td><font color="#DCE5C1" size=$VAR{'fsize'}><b>Period</b></font></td>
    <td><font color="#DCE5C1" size=$VAR{'fsize'}><b>Attempts</b></font></td>
    <td><font color="#DCE5C1" size=$VAR{'fsize'}><b>Check</b></font></td>
    <td><font color="#DCE5C1" size=$VAR{'fsize'}><b>Retry</b></font></td>
    <td><font color="#DCE5C1" size=$VAR{'fsize'}><b>Notification</b></font></td>
    <td><font color="#DCE5C1" size=$VAR{'fsize'}><b>Group</b></font></td>
    <td><font color="#DCE5C1" size=$VAR{'fsize'}><b>Period</b></font></td>
    <td><font color="#DCE5C1" size=$VAR{'fsize'}><b>Recovery</b></font></td>
    <td><font color="#DCE5C1" size=$VAR{'fsize'}><b>Critical</b></font></td>
    <td><font color="#DCE5C1" size=$VAR{'fsize'}><b>Warning</b></font></td>
    <td><font color="#DCE5C1" size=$VAR{'fsize'}><b>Handler</b></font></td>
    <td><font color="#DCE5C1" size=$VAR{'fsize'}><b>Command</b></font></td>
    <td><font color="#DCE5C1" size=$VAR{'fsize'}><b>Args</b></font></td>
    <td>&#160;</td>
  </tr>
EOF
	$csr = &my_open($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
	while ($ret = $csr->fetchrow_hashref)
	{
		if ($odd) { $odd=0; $color="E1E2ED";} else { $odd=1; $color="EEEEF4";}
		
		*data = $ret;

		if (length($data{'event_handler'}) <= 0) { $data{'event_handler'} = "&#160;"; }
		if (length($data{'check_arg'}) <= 0) { $data{'check_arg'} = "&#160;"; }
		$data{'notify_recovery'} = &YesNo($data{'notify_recovery'});
		$data{'notify_critical'} = &YesNo($data{'notify_critical'});
		$data{'notify_warning'} = &YesNo($data{'notify_warning'});

		print <<EOF;
  <tr bgcolor=$color>
    <td align=center><font size=$VAR{'esize'}><a href="edit_service.cgi?MODE=EDIT&service_id=$data{'service_id'}">Edit</a></font></td>
    <td ><font size=$VAR{'fsize'}>$data{'host'}</font></td>
    <td ><font size=$VAR{'fsize'}>$data{'description'}</font></td>
    <td align=center><font size=$VAR{'fsize'}>$data{'check_period'}</font></td>
    <td align=center><font size=$VAR{'fsize'}>$data{'max_attempts'}</font></td>
    <td align=center><font size=$VAR{'fsize'}>$data{'check_interval'}</font></td>
    <td align=center><font size=$VAR{'fsize'}>$data{'retry_interval'}</font></td>
    <td align=right><font size=$VAR{'fsize'}>$data{'notification_interval'}</font></td>
    <td align=center><font size=$VAR{'fsize'}>$data{'notification_group'}</font></td>
    <td align=center><font size=$VAR{'fsize'}>$data{'notification_period'}</font></td>
    <td align=center><font size=$VAR{'fsize'}>$data{'notify_recovery'}</font></td>
    <td align=center><font size=$VAR{'fsize'}>$data{'notify_critical'}</font></td>
    <td align=center><font size=$VAR{'fsize'}>$data{'notify_warning'}</font></td>
    <td align=center><font size=$VAR{'fsize'}>$data{'event_handler'}</font></td>
    <td ><font size=$VAR{'fsize'}>$data{'check_command'}</font></td>
    <td ><font size=$VAR{'fsize'}>$data{'check_arg'}</font></td>
    <td align=center><font size=$VAR{'dsize'}><a href="edit_service.cgi?MODE=DELETE&service_id=$data{'service_id'}">Delete</a></font></td>
  </tr>
EOF

	}

	print "</table>\n";

	print <<EOF;
<p><a href="edit_service.cgi?MODE=ADD">Add Service</a></p>
EOF

	#&my_close($csr);
}


sub List_Times_Comma
{
	my $timeperiod_name = shift;
	my $day = shift;
	my $space = shift;
	my @ret;
	my $sql;
	my $csr;
	my $retval = "";
	
	$sql = "select 
			substring(start, 1,5),
			substring(stop,1,5)
		from 
			time_day 
		where 
			timeperiod_name = '$timeperiod_name' 
		and 	day = '$day'
		";

	$csr = &my_open($dbh, $sql) || print "<p>$my_errstr<p>$sql</p>";
	while (@ret = &my_fetch($csr))
	{
		$retval .= "$ret[0]-$ret[1],";
		$retval .= " " if ($space == 1);
	}
	chop($retval);
	chop($retval) if ($space == 1);
	return $retval;
}


sub list_timeperiods
{
	my $csr;
	my $sql;
	local($ret);
	local(%data);
	my $odd = 1;
	my $color="";
	my $sun;
	my $mon;
	my $tue;
	my $wed;
	my $thu;
	my $fri;
	my $sat;

	$sql = "select
			*
		from
			timeperiod
		order by
			timeperiod_name
		";
	print <<EOF;
<p><a href="edit_timeperiod.cgi?MODE=ADD">Add Timeperiod</a></p>
EOF

	print <<EOF;
<table align=center cellpadding=1 cellspacing=1 border=0>
  <tr bgcolor=7172a2 align=center>
    <td colspan=1>&#160;</td>
    <td colspan=9 align=center><font color="#DCE5C1"><b>Timeperiods</b></font></td>
    <td colspan=1>&#160;</td>
  </tr>
  <tr bgcolor=7172a2 align=center>
    <td>&#160;</td>
    <td><font color="#DCE5C1" size=$VAR{'fsize'}><b>Name</b></font></td>
    <td><font color="#DCE5C1" size=$VAR{'fsize'}><b>Alias</b></font></td>
    <td><font color="#DCE5C1" size=$VAR{'fsize'}><b>Sun</b></font></td>
    <td><font color="#DCE5C1" size=$VAR{'fsize'}><b>Mon</b></font></td>
    <td><font color="#DCE5C1" size=$VAR{'fsize'}><b>Tue</b></font></td>
    <td><font color="#DCE5C1" size=$VAR{'fsize'}><b>Wed</b></font></td>
    <td><font color="#DCE5C1" size=$VAR{'fsize'}><b>Thu</b></font></td>
    <td><font color="#DCE5C1" size=$VAR{'fsize'}><b>Fri</b></font></td>
    <td><font color="#DCE5C1" size=$VAR{'fsize'}><b>Sat</b></font></td>
    <td>&#160;</td>
  </tr>
EOF
	$csr = &my_open($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
	while ($ret = $csr->fetchrow_hashref)
	{
		if ($odd) { $odd=0; $color="E1E2ED";} else { $odd=1; $color="EEEEF4";}
		
		*data = $ret;
		$sun = &List_Times_Comma($data{'timeperiod_name'}, "SUN", 1);
		$mon = &List_Times_Comma($data{'timeperiod_name'}, "MON", 1);
		$tue = &List_Times_Comma($data{'timeperiod_name'}, "TUE", 1);
		$wed = &List_Times_Comma($data{'timeperiod_name'}, "WED", 1);
		$thu = &List_Times_Comma($data{'timeperiod_name'}, "THU", 1);
		$fri = &List_Times_Comma($data{'timeperiod_name'}, "FRI", 1);
		$sat = &List_Times_Comma($data{'timeperiod_name'}, "SAT", 1);

		print <<EOF;
  <tr bgcolor=$color>
    <td><font size=$VAR{'esize'}><a href="edit_timeperiod.cgi?MODE=EDIT&old_timeperiod_name=$data{'timeperiod_name'}">Edit</a></font></td>
    <td><font size=$VAR{'fsize'}>$data{'timeperiod_name'}</font></td>
    <td><font size=$VAR{'fsize'}>$data{'timeperiod_alias'}</font></td>
    <td><font size=$VAR{'fsize'}>$sun <font size=$VAR{'esize'}>(<a href="edit_timeperiod.cgi?MODE=EDIT_DAY&day=SUN&timeperiod_name=$data{'timeperiod_name'}">Edit</a>)</font></td>
    <td><font size=$VAR{'fsize'}>$mon <font size=$VAR{'esize'}>(<a href="edit_timeperiod.cgi?MODE=EDIT_DAY&day=MON&timeperiod_name=$data{'timeperiod_name'}">Edit</a>)</font></td>
    <td><font size=$VAR{'fsize'}>$tue <font size=$VAR{'esize'}>(<a href="edit_timeperiod.cgi?MODE=EDIT_DAY&day=TUE&timeperiod_name=$data{'timeperiod_name'}">Edit</a>)</font></td>
    <td><font size=$VAR{'fsize'}>$wed <font size=$VAR{'esize'}>(<a href="edit_timeperiod.cgi?MODE=EDIT_DAY&day=WED&timeperiod_name=$data{'timeperiod_name'}">Edit</a>)</font></td>
    <td><font size=$VAR{'fsize'}>$thu <font size=$VAR{'esize'}>(<a href="edit_timeperiod.cgi?MODE=EDIT_DAY&day=THU&timeperiod_name=$data{'timeperiod_name'}">Edit</a>)</font></td>
    <td><font size=$VAR{'fsize'}>$fri <font size=$VAR{'esize'}>(<a href="edit_timeperiod.cgi?MODE=EDIT_DAY&day=FRI&timeperiod_name=$data{'timeperiod_name'}">Edit</a>)</font></td>
    <td><font size=$VAR{'fsize'}>$sat <font size=$VAR{'esize'}>(<a href="edit_timeperiod.cgi?MODE=EDIT_DAY&day=SAT&timeperiod_name=$data{'timeperiod_name'}">Edit</a>)</font></td>
    <td><font size=$VAR{'dsize'}><a href="edit_timeperiod.cgi?MODE=DELETE&timeperiod_name=$data{'timeperiod_name'}">Delete</a></font></td>
  </tr>
EOF

	}

	print "</table>\n";

	print <<EOF;
<p><a href="edit_timeperiod.cgi?MODE=ADD">Add Timeperiod</a></p>
EOF

	#&my_close($csr);
}


sub Zero_One
{
	local($name) = shift(@_);
	local($value)= shift(@_);
	local($retval) = "";
	local($zersel) = "";
	local($onesel) = "";

	if ($value == 0)
	{
		$zersel = "selected";
	}
	else
	{
		$onesel = "selected";
	}
	
	$retval = "<select name=$name>
<option value=0 $zersel>No</option>
<option value=1 $onesel>Yes</option>
</select>
";
	return $retval;
	
}


sub YesNo
{
	local($value) = shift(@_);

	if ($value == 0)
	{
		return "No";
	}
	else
	{
		return "Yes";
	}
}


sub load_cookie
{
	%cookies = fetch CGI::Cookie;
	if ((length($cookies{'NAME'}) > 0) && (length($in{'NAME'}) <= 0))
	{
		$in{'NAME'} = $cookies{'NAME'}->value;
	}
	if ((length($cookies{'PASSWORD'}) > 0) && (length($in{'PASSWORD'}) <= 0))
	{
		$in{'PASSWORD'} = $cookies{'PASSWORD'}->value;
	}
}


sub VerifyUsername
{
	local($sql);
	local($sth);
	local(@ret);
	local($cookie1) = "";
	local($cookie2) = "";

	$sql = " select * from users
		where name = '$in{'NAME'}'
		and   password = password('$in{'PASSWORD'}') ";

	if (!($sth = &my_open($dbh, $sql)))
	{
		print "Content-type: text/html\n\n";
		print <<EOF;
<html>
<head><title></title>
</head>
<body>
$my_errstr<p>$sql<p>
</body>
</html>
EOF
		exit(1);
	}
	else
	{
		if (!(@ret = $sth->fetchrow))
		{
#			&LogBadPw;
		print "Content-type: text/html\n\n";
			print <<EOF;
<html>

<head><title></title></head>
<body>
You are not authorized to use this service.  <!-- password --->
<p><a href="login.cgi">Please Login</a>
EOF
		print <<EOF;

</body>
</html>
EOF
			exit(1);
		}
		else
		{
			#$cookie1 = new CGI::Cookie(-name=>'NAME',-value=>$in{'NAME'},-path=>$cgibin,-expires=>'+90d');
			#$cookie2 = new CGI::Cookie(-name=>'PASSWORD',-value=>$in{'PASSWORD'},-path=>$cgibin,-expires=>'+90d');
			$cookie1 = new CGI::Cookie(-name=>'NAME',-value=>$in{'NAME'},-path=>$cgibin);
			$cookie2 = new CGI::Cookie(-name=>'PASSWORD',-value=>$in{'PASSWORD'},-path=>$cgibin);
			print header(-cookie=>[$cookie1,$cookie2]);
		}
	}
}


sub GetSecurityLevel
{
	return 0;
}
#sub GetSecurityLevel
#{
#	local($sql);
#	local($csr);
#	local(@ret);
#
#	$sql = "select security from users where name = '$in{'NAME'}'";
#	$csr = &my_open($dbh, $sql);
#	@ret = &my_fetch($csr);
#	return $ret[0];
#}

sub Build_Timeperiod_Select
{
	my $name = shift;
	my $value = shift;
	my $sql;
	my $csr;
	my @RET = "";
	my @ret;
	my $z = 0;

	$sql = "select timeperiod_name from timeperiod
		order by timeperiod_name";
	
	$csr = &my_open($dbh, $sql) || print "$my_errstr<p>$sql<p>\n";
	while (@ret = &my_fetch($csr))
	{
		$RET[$z++] = $ret[0];
	}
	return popup_menu(-name=>$name, -values=>\@RET, -default=>$value);
}

sub Build_Contactgroup_Select
{
	local($name) = shift(@_);
	local($value) = shift(@_);
	local(@ret);
	local($sql);
	local($csr);
	local($z) = 0;
	local(@ARRAY);

	$sql = "select group_name from contactgroup order by group_name";
	$csr = &my_open($dbh, $sql) || print "<p>$my_errstr<p>$sql</p>";
	while (@ret = &my_fetch($csr))
	{
		$ARRAY[$z++] = $ret[0];
	}
	return popup_menu(-name=>$name, -values=>\@ARRAY, -default=>$value);
}

1; #return true 

