#!/usr/bin/perl

require "netsaint-lib.pl";

print <<EOF;

<html>

<head>
<title>Netsaint config</title>
</head>

<body>
EOF

&list_down_history;

print <<EOF;
</body>
</html>

EOF

exit(1);


sub list_down_history
{
	local($csr);
	local($sql);
	local(%data);
	local($ret);
	local($key);
	
	$sql = "select * from TBFailureStatistics order by FailureDate";

	$csr = &my_open($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";

	print "<table border=1 >\n";
	print <<EOF;
<tr align=center>
  <td><b>Service</b></td>
  <td><b>Host</b></td>
  <td><b>Failure Date</b></td>
  <td><b>Recovery Date</b></td>
  <td><b>Downtime</b></td>
  <td><b>Message</b></td>
</tr>
EOF
	
	while ($ret = $csr->fetchrow_hashref)
	{
		*data = $ret;
		print <<EOF;
<tr align=center>
  <td nowrap>$data{'Service'}</td>
  <td valign=top>$data{'HostDescription'}</td>
  <td nowrap>$data{'FailureDate'}</td>
  <td nowrap>$data{'RecoveryDate'}</td>
  <td valign=top>$data{'DowntimeSec'}</td>
  <td valign=top>$data{'Message'}</td>
</tR>
EOF
	}
	print "</table>\n";
}

